package pps.core.common.excel;


import javax.validation.Validation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;
import java.util.List;

/**
 * 验证util
 *
 * @author ZWT
 * @date 2024/05/09
 */
public class ValidationUtil {

    public static Validator getValidator() {
        return validator;
    }

    static Validator validator;

    static {
        ValidatorFactory validatorFactory = Validation.buildDefaultValidatorFactory();
        validator = validatorFactory.getValidator();
    }

    /**
     * {
     *   "code": "DATA_VALID_FAILED",
     *   "msg": "数据校验失败",
     *   "data": [
     *     {
     *       "rowNum": 2,
     *       "errMsg": [
     *         "作者超出20长度"
     *       ]
     *     },
     *     {
     *       "rowNum": 3,
     *       "errMsg": [
     *         "出版日期格式(yyyy-MM-dd)有误",
     *         "作者超出20长度"
     *       ]
     *     }
     *   ]
     * }
     *
     * @param var1 var1
     * @param var2 var2
     */
    public static <T> void doValidate(List<T> var1, Class<?>... var2) {
//        List<ImportExpVO> expVOList = new ArrayList<>();
//        int rowNum = 1;
//        for (T var0 : var1) {
//            rowNum++; // 跳过标题行, 此为excel的行号
//            List<String> errMsg = new ArrayList<>();
//            Set<ConstraintViolation<T>> validateRstSet = ValidationUtil.getValidator().validate(var0, var2);
//            for (ConstraintViolation<T> constraintViolation : validateRstSet) {
//                errMsg.add(constraintViolation.getMessage());
//            }
//            if (errMsg.size() > 0) {
//                expVOList.add(ImportExpVO.builder().rowNum(rowNum).errMsg(errMsg).build());
//            }
//        }
//        if (expVOList.size() > 0) {
//            // 组装异常数据
//            throw new EasyExcelException(EasyExcelExtExceptionTypes.DATA_VALID_FAILED, expVOList);
//        }
    }
}